#include "fifosshcreator.h"



void add_date(char* nombre, char* prefix){
	char dia[128], hora[128];
	struct tm *tlocal;

	time_t tiempo = time(0);
	tlocal = localtime(&tiempo);
	strftime(dia,128,"%y-%m-%d",tlocal);
	strftime(hora,128,"%H:%M:%S",tlocal);

	sprintf(nombre, "%s_%s_%s.log", prefix, dia, hora);

}


void* read_fifo(void *ptr){
	int n;
	int fd_console_output;
	char buff[4096];
	char filename[100];
	FILE *fp_log;
	ot *otp=(ot *)ptr;
	
	//descriptor archivo para consola
	if((fd_console_output=open(otp->fifo_console_name,O_WRONLY))<0){
		printf("error fopen\n");
	}

	//apertura archivo para escritura del log
	add_date(filename,otp->namelog);
	fp_log = fopen (filename, "w");	
	if (fp_log == NULL) exit(1);

	while((n=read(otp->fd_input,buff,sizeof(buff)))>0){
		buff[n]='\0';		
		fprintf(fp_log,"%s",buff);	
		write(fd_console_output,buff,n);
	}
	close(otp->fd_input);
	close(fd_console_output);
	unlink(otp->fifo_console_name);
	fclose(fp_log);
}


int start_connection(pthread_t *tid1, char *userName, char *hostName, char *fifoIn, char *fifoOut, char *consoleTitle, char *consoleGeometry, char* namelog){
	int fdi, fdo, fdc; //descriptores de archivo para 
				//'entrada connexion shh', 
				//'salida connexion shh' y
				//'entrada a consola de despliegue' 

	//se abre conexion ssh y se obtienen las pipas de comunicacion
	sshComunicator(userName,hostName, fifoIn, fifoOut);
	
	//console fifooutput
	char* cfo = getconsole(consoleTitle, consoleGeometry);

	if((fdi=open(fifoIn,O_WRONLY))<0){
		printf("error fopen\n");
		return -1;
	}

	if((fdo=open(fifoOut,O_RDONLY))<0){
		printf("error fopen\n");
		return -1;
	}

	ot *pot=malloc(sizeof(ot));
	pot->fd_input=fdo;
	pot->fifo_console_name=cfo;
	pot->namelog=namelog;

	if (pthread_create(tid1, NULL, read_fifo, (void *)pot) != 0){
		printf("error thread create\n");
	}
	return fdi;

}



void sshComunicator(char *userName, char *hostName, char *finputname, char *foutputname){

	pid_t pid_ssh; // pid procesos hijos 
	int status_ssh; // retornos procesos hijos
	
	char ssh_command[200];

	if(finputname != NULL){ 
		unlink(finputname);
	}
	if(foutputname != NULL) {
		unlink(foutputname);
	}

	/*
	 * Create the FIFOWRITE and FIFOREAD.
	 */
	if (mkfifo(finputname, 0666) < 0) {
		perror("mkfifo");
		exit(1);
	}
	if (mkfifo(foutputname, 0666) < 0) {
		perror("mkfifo");
		exit(1);
	}



	if ((pid_ssh = fork()) < 0) {
		perror("fork");
		exit(1);
	}

	if (pid_ssh == 0) {

 		strcpy(ssh_command, "ssh ");
		strcat(ssh_command, userName);
		strcat(ssh_command, "@");
		strcat(ssh_command, hostName);
		strcat(ssh_command, " < ");
		strcat(ssh_command, finputname);
		strcat(ssh_command, " | cat > ");
		strcat(ssh_command, foutputname);
		strcat(ssh_command, " &");
		printf("-->Generando comando de conexión a ssh:%s\n", ssh_command);
		system(ssh_command);

		perror("exec");
		_exit(127);
	}

	/*
	 * wait for child
	 */
	waitpid(pid_ssh, &status_ssh, 0);
}


char* getconsole(char *title, char *geometry){

	char cat_command[32];
	pid_t pid_gt;
	int status_gt; // retornos proceso hijo
	char* fconsole = (char*) malloc(sizeof(char)*20);

	sprintf(fconsole, "foc_%d\0",(rand()%100001));
	unlink(fconsole);

	if (mkfifo(fconsole, 0666) < 0) {
		perror("mkfifo");
		exit(1);
	}
	/*
	 * Create a fork for "gnome-terminal" and "ssh command".
	 */	
	if ((pid_gt = fork()) < 0) {
		perror("fork");
		exit(1);
	}

	/*
	 * The child process executes "gnome-terminal" for show stdout.
	 */
	if (pid_gt == 0) {
		strcpy(cat_command, "cat ");
		strcat(cat_command, fconsole);
		if(geometry == NULL){
			execlp("gnome-terminal","gnome-terminal", "-t", title, "--hide-menubar","-e", cat_command, (char *) 0);
		}else{
			execlp("gnome-terminal","gnome-terminal", "-t", title, "--hide-menubar", "--geometry", geometry, "-e", cat_command, (char *) 0);
		}
		perror("exec");
		_exit(127);
	}
	/*
	 * wait for child
	 */
	waitpid(pid_gt, &status_gt, 0);

	return fconsole;
}
