#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <pthread.h>
#include <time.h>
#include <string.h>


#define MSG_EXIT "exit\n" 
#define SIZEOF_EXIT 5 


/*
 * estructura que sirve para que la función
 * 'read_fifo' obtenga los
 *  descriptores de archivo desde 
 *  donde leer y donde desplegar
 */
typedef struct outThread {
		int fd_input;
		char *fifo_console_name;
		char *namelog;
} ot;

/*
 *nombre: Nombre del buffer a llenar.
 *prefix: prefijo del string guardado en el buffer.
 **/
void add_date(char* nombre, char* prefix);

/*
 *ptr: Puntero a una estructura de tipo ot.
 **/
void* read_fifo(void *ptr);


/*
 *tid1: Puntero a una hebra.
 *userName: Nombre del usuario para conectarse al servidor ssh.
 *hostName: Dirección IP del servidor ssh.
 *fifoIn: Puntero a un fifo para recibir datos.
 *fifoOut: Puntero a un fifo para enviar datos.
 *consoleTitle: Nombre de la consola.
 *consoleGeometry: Detalles del aspecto de la consola.
 *namelog: Prefijo para un archivo .log
 **/
int start_connection(pthread_t *tid1, char *userName, char *hostName, char *fifoIn, char *fifoOut, char *consoleTitle, char *consoleGeometry, char* namelog);

/*
 *userName: nombre de usuario (not NULL) 
 *hostName: nombre de host (not NULL) 
 *finputname: nombre de la pipa de entrada (not NULL)
 *foutputname: nombre de la pipa de salida (not NULL)
 **/
void sshComunicator(char *userName, char *hostName, char *finputname, char *foutputname);

/*
 *title: titulo de la consola (not NULL) 
 *geometry: puede ser NULL. (ver parametro --geometry en 'man gnome-terminal')
 **/
char* getconsole(char *title, char *geometry);
